import { Element, ElementAttributes } from '@lume/element';
import { BundledLanguage, BundledTheme } from 'shiki/types.mjs';

/**********************************************************************************/
/**********************************************************************************/
interface ShikiTextareaAttributes extends Omit<ElementAttributes<ShikiTextareaElement, 'cdn' | 'lang' | 'theme' | 'value'>, 'onInput' | 'oninput'> {
    oninput?: (event: InputEvent & {
        target: HTMLTextAreaElement;
    }) => any;
    onInput?: (event: InputEvent & {
        target: HTMLTextAreaElement;
    }) => any;
}
declare module 'solid-js/jsx-runtime' {
    namespace JSX {
        interface IntrinsicElements {
            'shiki-textarea': ShikiTextareaAttributes;
        }
    }
}
declare global {
    namespace JSX {
        interface IntrinsicElements {
            'shiki-textarea': ShikiTextareaAttributes;
        }
    }
}
declare class ShikiTextareaElement extends Element {
    lang: BundledLanguage;
    cdn: string;
    theme: BundledTheme;
    value: string;
    template: () => import("@lume/element").JSX.Element;
    static css: string;
}
/**
 * NOOP to prevent <shiki-textarea/> to be treeshaken out.
 */
export declare function registerShikiTextarea(): void;
export {};
