/**
 * A textarea with syntax highlighting capabilities powered by [shiki](https://github.com/shikijs/shiki).
 *
 * @example static import
 * ```tsx
 * import andromeeda from "shiki/themes/andromeeda.mjs"
 * import tsx from "shiki/langs/tsx.mjs"
 * return (
 *  <ShikiTextArea
 *    theme={andromeeda}
 *    lang={tsx}
 *  />
 * )
 * ```
 * @example dynamic import
 * ```tsx
 * return (
 *  <ShikiTextArea
 *    theme={import('shiki/themes/andromeeda.mjs')}
 *    lang={import('shiki/langs/tsx.mjs')}
 *  />
 * )
 * ```
 */
export declare const ShikiTextarea: (props: import('./core').ShikiTextareaProps) => import("solid-js/jsx-runtime").JSX.Element;
