import { use, spread, mergeProps, insert, createComponent, setAttribute, effect, className, Dynamic, delegateEvents, template } from "solid-js/web";
import { createMemo, onCleanup, $TRACK, untrack, batch, createRoot, createSignal, splitProps, createResource, useTransition, createEffect, Suspense, Show, Index } from "solid-js";
import { getHighlighterCore } from "shiki";
import './index.css';function disposeList(list) {
  var _a;
  for (let i = 0; i < list.length; i++) {
    (_a = list[i]) == null ? void 0 : _a.disposer();
  }
}
function listArray(list, mapFn, options = {}) {
  const items = [];
  let mapped = [], unusedItems, i, j, item, oldValue, oldIndex, newValue, fallback, fallbackDisposer;
  onCleanup(() => {
    fallbackDisposer == null ? void 0 : fallbackDisposer();
    fallbackDisposer = void 0;
    disposeList(items);
  });
  return () => {
    const newItems = list() || [];
    newItems[$TRACK];
    return untrack(() => {
      var _a, _b, _c, _d;
      if (newItems.length > 0 && fallbackDisposer) {
        fallbackDisposer();
        fallbackDisposer = void 0;
        fallback = void 0;
      }
      const temp = new Array(newItems.length);
      unusedItems = items.length;
      for (j = unusedItems - 1; j >= 0; --j) {
        item = items[j];
        oldIndex = item.index;
        if (oldIndex < newItems.length && newItems[oldIndex] === item.value) {
          temp[oldIndex] = mapped[oldIndex];
          if (--unusedItems !== j) {
            items[j] = items[unusedItems];
            items[unusedItems] = item;
          }
        }
      }
      const matcher = /* @__PURE__ */ new Map();
      const matchedItems = new Uint8Array(unusedItems);
      for (j = unusedItems - 1; j >= 0; --j) {
        oldValue = items[j].value;
        ((_a = matcher.get(oldValue)) == null ? void 0 : _a.push(j)) ?? matcher.set(oldValue, [j]);
      }
      for (i = 0; i < newItems.length; ++i) {
        if (i in temp)
          continue;
        newValue = newItems[i];
        j = ((_b = matcher.get(newValue)) == null ? void 0 : _b.pop()) ?? -1;
        if (j >= 0) {
          item = items[j];
          oldIndex = item.index;
          temp[i] = mapped[oldIndex];
          item.index = i;
          (_c = item.indexSetter) == null ? void 0 : _c.call(item, i);
          matchedItems[j] = 1;
        }
      }
      for (j = matchedItems.length - 1; j >= 0; --j) {
        if (matchedItems[j] && --unusedItems !== j) {
          item = items[j];
          items[j] = items[unusedItems];
          items[unusedItems] = item;
        }
      }
      for (j = unusedItems - 1; j >= 0; --j) {
        item = items[j];
        oldIndex = item.index;
        if (!(oldIndex in temp) && oldIndex < newItems.length) {
          temp[oldIndex] = mapped[oldIndex];
          newValue = newItems[oldIndex];
          item.value = newValue;
          (_d = item.valueSetter) == null ? void 0 : _d.call(item, newValueGetter);
          if (--unusedItems !== j) {
            items[j] = items[unusedItems];
            items[unusedItems] = item;
          }
        }
      }
      for (i = 0; i < newItems.length; ++i) {
        if (i in temp)
          continue;
        newValue = newItems[i];
        if (unusedItems > 0) {
          item = items[--unusedItems];
          temp[i] = mapped[item.index];
          batch(changeBoth);
        } else {
          temp[i] = createRoot(mapper);
        }
      }
      disposeList(items.splice(0, unusedItems));
      if (newItems.length === 0 && options.fallback) {
        if (!fallbackDisposer) {
          fallback = [
            createRoot((d) => {
              fallbackDisposer = d;
              return options.fallback();
            })
          ];
        }
        return fallback;
      }
      return mapped = temp;
    });
  };
  function newValueGetter() {
    return newValue;
  }
  function changeBoth() {
    var _a, _b;
    item.index = i;
    (_a = item.indexSetter) == null ? void 0 : _a.call(item, i);
    item.value = newValue;
    (_b = item.valueSetter) == null ? void 0 : _b.call(item, newValueGetter);
  }
  function mapper(disposer) {
    const t = {
      value: newValue,
      index: i,
      disposer
    }, scopedV = newValue, scopedI = i;
    items.push(t);
    let sV = () => {
      [sV, t.valueSetter] = createSignal(scopedV, { name: "value" });
      return sV();
    }, sI = () => {
      [sI, t.indexSetter] = createSignal(scopedI, { name: "index" });
      return sI();
    };
    return mapFn(
      () => sV(),
      () => sI()
    );
  }
}
function List(props) {
  const fallback = "fallback" in props && { fallback: () => props.fallback };
  return createMemo(
    listArray(() => props.each, props.children, fallback || void 0),
    void 0,
    { name: "value" }
  );
}
function r(e) {
  var t, f, n = "";
  if ("string" == typeof e || "number" == typeof e)
    n += e;
  else if ("object" == typeof e)
    if (Array.isArray(e)) {
      var o = e.length;
      for (t = 0; t < o; t++)
        e[t] && (f = r(e[t])) && (n && (n += " "), n += f);
    } else
      for (f in e)
        e[f] && (n && (n += " "), n += f);
  return n;
}
function clsx() {
  for (var e, t, f = 0, n = "", o = arguments.length; f < o; f++)
    (e = arguments[f]) && (t = r(e)) && (n && (n += " "), n += t);
  return n;
}
function hexToRgb(hex) {
  let bigint = parseInt(hex.slice(1), 16);
  let r2 = bigint >> 16 & 255;
  let g = bigint >> 8 & 255;
  let b = bigint & 255;
  return [r2, g, b];
}
function rgbToHsl(r2, g, b) {
  r2 /= 255;
  g /= 255;
  b /= 255;
  const max = Math.max(r2, g, b);
  const min = Math.min(r2, g, b);
  let h = (max + min) / 2;
  let s = (max + min) / 2;
  let l = (max + min) / 2;
  if (max === min) {
    h = s = 0;
  } else {
    const d = max - min;
    s = l > 0.5 ? d / (2 - max - min) : d / (max + min);
    switch (max) {
      case r2:
        h = (g - b) / d + (g < b ? 6 : 0);
        break;
      case g:
        h = (b - r2) / d + 2;
        break;
      case b:
        h = (r2 - g) / d + 4;
        break;
    }
    h /= 6;
  }
  return [h, s, l];
}
function hslToRgb(h, s, l) {
  let r2, g, b;
  if (s === 0) {
    r2 = g = b = l;
  } else {
    const hue2rgb = (p2, q2, t) => {
      if (t < 0)
        t += 1;
      if (t > 1)
        t -= 1;
      if (t < 1 / 6)
        return p2 + (q2 - p2) * 6 * t;
      if (t < 1 / 2)
        return q2;
      if (t < 2 / 3)
        return p2 + (q2 - p2) * (2 / 3 - t) * 6;
      return p2;
    };
    const q = l < 0.5 ? l * (1 + s) : l + s - l * s;
    const p = 2 * l - q;
    r2 = hue2rgb(p, q, h + 1 / 3);
    g = hue2rgb(p, q, h);
    b = hue2rgb(p, q, h - 1 / 3);
  }
  return [Math.round(r2 * 255), Math.round(g * 255), Math.round(b * 255)];
}
function luminance(r2, g, b) {
  const a = [r2, g, b].map((v) => {
    v /= 255;
    return v <= 0.03928 ? v / 12.92 : Math.pow((v + 0.055) / 1.055, 2.4);
  });
  return a[0] * 0.2126 + a[1] * 0.7152 + a[2] * 0.0722;
}
function contrast(rgb1, rgb2) {
  const lum1 = luminance(...rgb1);
  const lum2 = luminance(...rgb2);
  const brightest = Math.max(lum1, lum2);
  const darkest = Math.min(lum1, lum2);
  return (brightest + 0.05) / (darkest + 0.05);
}
const CACHE$1 = /* @__PURE__ */ new Map();
function calculateContrastingColor(backgroundHex) {
  const cached = CACHE$1.get(backgroundHex);
  if (cached)
    return cached;
  const backgroundRgb = hexToRgb(backgroundHex);
  let adjustedColor = backgroundRgb;
  let hsl = rgbToHsl(adjustedColor[0], adjustedColor[1], adjustedColor[2]);
  const isDark = hsl[2] < 0.5;
  let newContrastRatio = 0;
  let count = 0;
  while (count < 200) {
    hsl[2] += isDark ? 1e-3 : -1e-3;
    if (hsl[2] <= 0 || hsl[2] >= 1) {
      break;
    }
    adjustedColor = hslToRgb(hsl[0], hsl[1], hsl[2]);
    newContrastRatio = contrast(adjustedColor, backgroundRgb);
    if (newContrastRatio > 4.5) {
      break;
    }
    count++;
  }
  const result = `#${((1 << 24) + (adjustedColor[0] << 16) + (adjustedColor[1] << 8) + adjustedColor[2]).toString(16).slice(1).toUpperCase()}`;
  CACHE$1.set(backgroundHex, result);
  return result;
}
function when(accessor, callback, fallback) {
  const value = typeof accessor === "function" ? accessor() : accessor;
  return value ? callback(value) : fallback ? fallback() : void 0;
}
function whenever(accessor, callback, fallback) {
  return () => when(accessor, callback, fallback);
}
function every(...accessors) {
  function callback() {
    const values = new Array(accessors.length);
    for (let i = 0; i < accessors.length; i++) {
      const _value = typeof accessors[i] === "function" ? accessors[i]() : accessors[i];
      if (!_value)
        return void 0;
      values[i] = _value;
    }
    return values;
  }
  return callback;
}
function getLineCount(value) {
  return value.split("\n").length;
}
function getLineSize(value) {
  let lineSize = -Infinity;
  value.split("\n").forEach((line) => {
    if (line.length > lineSize) {
      lineSize = line.length;
    }
  });
  return lineSize;
}
var _tmpl$ = /* @__PURE__ */ template(`<div><div><textarea inputmode=none autocomplete=off></textarea><code aria-hidden>`);
async function resolve(value) {
  if (value instanceof Promise) {
    const awaitedValue = await value;
    if ("default" in awaitedValue) {
      return awaitedValue.default;
    }
    return awaitedValue;
  }
  return value;
}
const loadWasm = import("shiki/wasm");
const CACHE = /* @__PURE__ */ new WeakMap();
function getCachedHighlighter([theme, lang]) {
  let highlighters = CACHE.get(theme);
  if (!highlighters) {
    CACHE.set(theme, /* @__PURE__ */ new WeakMap());
    highlighters = CACHE.get(theme);
  }
  let highlighter = highlighters.get(lang);
  if (!highlighter) {
    highlighter = getHighlighterCore({
      themes: [theme],
      langs: [lang],
      loadWasm
    });
    highlighters.set(lang, highlighter);
  }
  return highlighter;
}
function createShikiTextarea(styles2) {
  return function ShikiTextarea2(props) {
    const [config, rest] = splitProps(props, ["class", "defaultValue", "lang", "onInput", "value", "style", "theme"]);
    const [source, setSource] = createSignal(config.defaultValue || config.value);
    const [characterDimensions, setCharacterDimensions] = createSignal({
      width: 0,
      height: 0
    });
    const [theme] = createResource(() => config.theme, resolve);
    const [lang] = createResource(() => config.lang, resolve);
    const [highlighter] = createResource(every(theme, lang), getCachedHighlighter);
    const hast = createMemo((previous) => {
      var _a;
      const _highlighter = highlighter();
      const _lang = (_a = untrack(lang)) == null ? void 0 : _a[0];
      const _theme = untrack(theme);
      if (!_highlighter || !_lang || !_theme)
        return previous;
      const _source = source();
      if (!source)
        return void 0;
      const hast2 = _highlighter.codeToHast(_source, {
        lang: _lang.name,
        theme: _theme
      });
      if (!hast2.children[0])
        return previous;
      return hast2.children[0];
    });
    const themeStyles = whenever(every(theme, highlighter), ([theme2, highlighter2]) => {
      const {
        fg,
        bg
      } = highlighter2.getTheme(theme2);
      return {
        "--selection-color": calculateContrastingColor(bg),
        "--background-color": bg,
        "--foreground-color": fg
      };
    });
    const [, startTransition] = useTransition();
    function updateSource(source2) {
      startTransition(() => setSource(source2));
    }
    createEffect(() => updateSource(config.value));
    return (() => {
      var _el$ = _tmpl$(), _el$2 = _el$.firstChild, _el$3 = _el$2.firstChild, _el$4 = _el$3.nextSibling;
      var _ref$ = props.ref;
      typeof _ref$ === "function" ? use(_ref$, _el$) : props.ref = _el$;
      spread(_el$, mergeProps({
        get ["class"]() {
          return clsx(styles2.editor, config.class);
        },
        get style() {
          return {
            ...themeStyles(),
            ...config.style
          };
        }
      }, rest), false, true);
      insert(_el$2, createComponent(Suspense, {
        get children() {
          return createComponent(List, {
            get each() {
              return when(hast, (hast2) => "children" in hast2 && hast2.children);
            },
            children: (line) => createComponent(HastNode, {
              get node() {
                return line();
              }
            })
          });
        }
      }), _el$3);
      _el$3.$$input = (e) => {
        var _a;
        const value = e.currentTarget.value;
        updateSource(value);
        (_a = config.onInput) == null ? void 0 : _a.call(config, e);
      };
      setAttribute(_el$3, "spellcheck", false);
      use((character2) => {
        const resizeObserver = new ResizeObserver(([entry]) => {
          setCharacterDimensions(entry.contentRect);
        });
        resizeObserver.observe(character2);
        onCleanup(() => resizeObserver.disconnect());
      }, _el$4);
      _el$4.innerHTML = "&nbsp;";
      effect((_p$) => {
        var _v$ = styles2.container, _v$2 = `${Math.ceil(getLineSize(source()) * characterDimensions().width + 1)}px`, _v$3 = `${Math.ceil(getLineCount(source()) * characterDimensions().height)}px`, _v$4 = styles2.textarea, _v$5 = styles2.character;
        _v$ !== _p$.e && className(_el$2, _p$.e = _v$);
        _v$2 !== _p$.t && ((_p$.t = _v$2) != null ? _el$2.style.setProperty("min-width", _v$2) : _el$2.style.removeProperty("min-width"));
        _v$3 !== _p$.a && ((_p$.a = _v$3) != null ? _el$2.style.setProperty("min-height", _v$3) : _el$2.style.removeProperty("min-height"));
        _v$4 !== _p$.o && className(_el$3, _p$.o = _v$4);
        _v$5 !== _p$.i && className(_el$4, _p$.i = _v$5);
        return _p$;
      }, {
        e: void 0,
        t: void 0,
        a: void 0,
        o: void 0,
        i: void 0
      });
      effect(() => _el$3.value = config.value);
      return _el$;
    })();
  };
}
function HastNode(props) {
  return createComponent(Show, {
    get when() {
      return props.node.type !== "text" && props.node;
    },
    get fallback() {
      return props.node.value;
    },
    children: (node) => createComponent(Dynamic, mergeProps({
      get component() {
        return node().tagName || "div";
      }
    }, () => node().properties, {
      get children() {
        return createComponent(Index, {
          get each() {
            return node().children;
          },
          children: (child) => createComponent(HastNode, {
            get node() {
              return child();
            }
          })
        });
      }
    }))
  });
}
delegateEvents(["input"]);
const editor = "index-module__editor___WoVwR";
const container = "index-module__container___GdQY1";
const character = "index-module__character___mhd0f";
const textarea = "index-module__textarea___cMW-q";
const styles = {
  editor,
  container,
  character,
  textarea
};
const ShikiTextarea = createShikiTextarea(styles);
export {
  ShikiTextarea
};
